#ifdef __GNUC__
#define UNUSED __attribute__ ((unused))
#else
#define UNUSED
#endif

/* ********************************************************************************** */
/*                                                                                    */
/*                             Likelihood Functions                                   */
/*                                                                                    */
/* ********************************************************************************** */

double loglike(int imin, int imax, double *r, double Sn, double *Snf);
double loglike_stochastic(int NI, int imin, int imax, double **r, double ***invCij, double *detC);
double loglike_maxNET(struct Data *data, struct Prior *prior, double **sNET, double **hNET, double **SnfNET, double **invSnfNET, double *SnNET, double t0, double *dt, double *dphi, double *dA);

void recompute_residual(struct Data *data, struct Model **model, struct Chain *chain);

double Sum_Extreme(double **a, double **b, double **Sn, int n, double *delt, double *pshift, double Tobs, int NI, int imin, int imax, double t0);

double EvaluateSearchLogLikelihood   (int typ, int ii, int det, struct Model *mx, struct Model *my, struct Prior *prior, struct Chain *chain, struct Data *data);
double EvaluateConstantLogLikelihood (int typ, int ii, int det, UNUSED struct Model *mx, struct Model *my, struct Prior *prior, UNUSED struct Chain *chain, UNUSED struct Data *data);
double EvaluateMarkovianLogLikelihood(int typ, int ii, int det, struct Model *mx, struct Model *my, struct Prior *prior, struct Chain *chain, struct Data *data);

double EvaluateExtrinsicSearchLogLikelihood   (struct Network *projection, double *params, double **invSnf, double *Sn, double *geo, double **g, struct Data *data, double fmin, double fmax);
double EvaluateExtrinsicConstantLogLikelihood (UNUSED struct Network *projection, double *params, UNUSED double **invSnf, UNUSED double *Sn, UNUSED double *geo, UNUSED double **g, UNUSED struct Data *data, UNUSED double fmin, UNUSED double fmax);
double EvaluateExtrinsicMarkovianLogLikelihood(struct Network *projection, double *params, double **invSnf, double *Sn, double *geo, double **g, struct Data *data, double fmin, double fmax);



void phase_blind_time_shift(double *corr, double *corrf, double *data1, double *data2, double *psd, int n);
